﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ListView1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            setGUI();
        }

    
        private void  setGUI() {
            cbStyle.Items.Clear();
            cbStyle.Items.Add("Small Icons");
            cbStyle.Items.Add("Large Icons");
            cbStyle.Items.Add("Liste");
            cbStyle.Items.Add("Details");
            cbStyle.SelectedIndex = 3;
            
            listView1.View = View.Details;		// Report vs. Details
            listView1.LabelEdit = true;		// EditModus
            listView1.AllowColumnReorder = true;	// Spalten verschieben
            listView1.CheckBoxes = true;		// CheckBox
            listView1.FullRowSelect = true;		// zeilenweise markieren
            listView1.GridLines = true;		// Gitterlinien

            // Sortiere den ersten Eintrag (Alphanumerisch)
            listView1.Sorting = SortOrder.Ascending;	
            // Spalten
            listView1.Columns.Add("Nr", 100, HorizontalAlignment.Left);
            listView1.Columns.Add("Name", 50, HorizontalAlignment.Left);
            listView1.Columns.Add("Matrnr", 60, HorizontalAlignment.Left);
            listView1.Columns.Add("Note", 80, HorizontalAlignment.Center);


             // Symbole (small und large)
            ImageList imageListSmall = new ImageList();
            ImageList imageListLarge = new ImageList();

              // Initialize the ImageList objects with bitmaps.
            imageListSmall.Images.Add(Bitmap.FromFile("MySmallImage1.bmp"));
            imageListSmall.Images.Add(Bitmap.FromFile("MySmallImage2.bmp"));
            imageListLarge.Images.Add(Bitmap.FromFile("MyLargeImage1.bmp"));
            imageListLarge.Images.Add(Bitmap.FromFile("MyLargeImage2.bmp"));

            // Zuweisung
            listView1.LargeImageList = imageListLarge;
            listView1.SmallImageList = imageListSmall;

            ListViewItem item1 = new ListViewItem("1", 0);  // 0 = 1. Bild
            item1.Checked = true;
            item1.SubItems.Add("Meyer");	// next Column
            item1.SubItems.Add("14721");
            item1.SubItems.Add("4.0");
            listView1.Items.Add(item1);

            ListViewItem item2 = new ListViewItem("2", 1); // 1 = 2. Bild
            item2.SubItems.Add("Schulze");
            item2.SubItems.Add("16234");
            item2.SubItems.Add("1.3");
            listView1.Items.Add(item2);

            ListViewItem item3 = new ListViewItem("3", 1); // 1 = 2. Bild
            item3.SubItems.Add("Brandt");
            item3.SubItems.Add("14234");
            item3.SubItems.Add("2.7");
            listView1.Items.Add(item3);

            ListViewItem item4 = new ListViewItem("11", 1); // 1 = 2. Bild
            item4.SubItems.Add("Schmidt");
            item4.SubItems.Add("17234");
            item4.SubItems.Add("2.0");
            listView1.Items.Add(item4);

            numericUpDown1.Minimum = 0;
            numericUpDown1.Maximum = listView1.Items.Count - 1;
            numericUpDown1.Value = 0;
        }

        private void chbGridlines_CheckedChanged(object sender, EventArgs e)
        {
            listView1.GridLines = chbGridlines.Checked; 
        }

        private void chbChecked_CheckedChanged(object sender, EventArgs e)
        {
            listView1.CheckBoxes = chbChecked.Checked;
        }

        private void cbStyle_SelectedIndexChanged(object sender, EventArgs e)
        {
            int i = cbStyle.SelectedIndex;
            switch (i)
            {
                case 0: listView1.View = View.SmallIcon;
                    break;
                case 1: listView1.View = View.LargeIcon;
                    break;
                case 2: listView1.View = View.List; // .Tile;  Tile nur ohne CheckBox
                    break;
                case 3: listView1.View = View.Details;
                    break;
            }
        }

        private void BnAdd_Click(object sender, EventArgs e)
        {
            // Check auf Leerstring
            string sStr = textBox1.Text.Trim();
            if (sStr.Equals("")) return;

            ListViewItem item = new ListViewItem(sStr, 0); // 1 = 2. Bild
            item.SubItems.Add("-");
            item.SubItems.Add("-");
            item.SubItems.Add("-");
            listView1.Items.Add(item);
            numericUpDown1.Maximum = listView1.Items.Count - 1;
        }

        private void BnInsert_Click(object sender, EventArgs e)
        {
            // Check auf Leerstring
            string sStr = textBox1.Text.Trim();
            if (sStr.Equals("")) return;
            int position = (int) numericUpDown1.Value; // liefert decimal

            ListViewItem item = new ListViewItem(sStr, 0); // 1 = 2. Bild
            item.SubItems.Add("-");
            item.SubItems.Add("-");
            item.SubItems.Add("-");
            listView1.Items.Insert(position,item);
            numericUpDown1.Maximum = listView1.Items.Count - 1;
        }

        private void chbSort_CheckedChanged(object sender, EventArgs e)
        {
            if (chbSort.Checked)
                listView1.Sorting = SortOrder.Ascending;
            else
                listView1.Sorting = SortOrder.None;
        }
       //        public virtual void RemoveAt(   int index );

    }
}
